/********************************************************************************
*
*	File: win_main.cpp
*	Copyright(c) Andreas Magnusson 2002
*
*	Just very basic stuff...a testbed for my image-factory!
*
*	DISCLAIMER AND STUFF:
*	This source-code is supplied AS IS. I cannot be held responsible for any damage caused
*	by use or misuse of this source-code. So use the code as you please, but give credit
*	where they are due.
*
********************************************************************************/
#include <windows.h>
// disable the annoying warnings that comes up when you use map...
#pragma warning( disable : 4786)
#include "image.h"

const char *CLASSNAME = "IMAGEVIEW", *WINNAME = "Image View";

LRESULT CALLBACK WndProc(HWND hWnd, unsigned int iMessage, WPARAM wParam, LPARAM lParam);

image_hnd img_array[5];

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE, LPSTR, int nCmdShow)
{
	HWND hWnd;
	MSG Message;
	WNDCLASS WndClass;
	ZeroMemory(&WndClass, sizeof(WNDCLASS));
	WndClass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
	WndClass.hIcon = LoadIcon(hInstance, NULL);
	WndClass.hInstance = hInstance;
	WndClass.lpfnWndProc = WndProc;
	WndClass.lpszClassName = CLASSNAME;
	WndClass.style = CS_HREDRAW | CS_VREDRAW;
	if(!RegisterClass(&WndClass))
		return 0;
        
	hWnd = CreateWindow(CLASSNAME, WINNAME, WS_OVERLAPPEDWINDOW,
											CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
											NULL, NULL, hInstance, NULL);

	img_array[0] = load_image("forest.bmp");
	save_image("forest.pcx", img_array[0]);

	ShowWindow(hWnd, nCmdShow);

	while(GetMessage(&Message, hWnd, 0, 0))
	{
		TranslateMessage(&Message);
		DispatchMessage(&Message);
	}
	return Message.wParam;
}

COLORREF make_color(const unsigned char *buf)
{
	COLORREF cl = buf[0] | (buf[1] << 8) | (buf[2] << 16);
	return cl;
}

void draw_image(HDC hdc, int ystart, image_hnd &img)
{
	if(img.is_null())
		return;
	for(int y = 0; y < img->get_height(); y++)
	{
		for(int x = 0; x < img->get_width(); x++)
		{
			COLORREF cl = make_color(&img->get_bits()[y * 3 * img->get_width() + x * 3]);
			SetPixel(hdc, x, y + ystart, cl);
		}
	}
}

LRESULT CALLBACK WndProc(HWND hWnd, unsigned int iMessage, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	int ystart, i;
	switch(iMessage)
	{
	case WM_PAINT:
		BeginPaint(hWnd, &ps);
		ystart = 0;
		for(i = 0; i < 5; i++)
		{
			if(!img_array[i].is_null())
			{
				draw_image(ps.hdc, ystart, img_array[i]);
				ystart += img_array[i]->get_height() + 1;
			}
		}
		EndPaint(hWnd, &ps);
		break;
	case WM_CLOSE:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, iMessage, wParam, lParam);
	}
	return 0;
}

